Index: squid/src/ftp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ftp.c,v
retrieving revision 1.1.1.3.4.3.2.1
retrieving revision 1.1.1.3.4.3.2.1.2.1
diff -u -r1.1.1.3.4.3.2.1 -r1.1.1.3.4.3.2.1.2.1
--- squid/src/ftp.c	6 Jan 2001 12:40:14 -0000	1.1.1.3.4.3.2.1
+++ squid/src/ftp.c	27 Aug 2001 21:48:21 -0000	1.1.1.3.4.3.2.1.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: ftp.c,v 1.1.1.3.4.3.2.1 2001/01/06 12:40:14 hno Exp $
+ * $Id: ftp.c,v 1.1.1.3.4.3.2.1.2.1 2001/08/27 21:48:21 tolsty Exp $
  *
  * DEBUG: section 9     File Transfer Protocol (FTP)
  * AUTHOR: Harvest Derived
@@ -39,7 +38,8 @@
 static const char *const crlf = "\r\n";
 static char cbuf[1024];
 
-typedef enum {
+typedef enum
+{
     BEGIN,
     SENT_USER,
     SENT_PASS,
@@ -58,9 +58,11 @@
     READING_DATA,
     WRITING_DATA,
     SENT_MKDIR
-} ftp_state_t;
+}
+ftp_state_t;
 
-struct _ftp_flags {
+struct _ftp_flags
+{
     unsigned int isdir:1;
     unsigned int pasv_supported:1;
     unsigned int skip_whitespace:1;
@@ -81,7 +83,8 @@
     unsigned int datachannel_hack:1;
 };
 
-typedef struct _Ftpdata {
+typedef struct _Ftpdata
+{
     StoreEntry *entry;
     request_t *request;
     char user[MAX_URL];
@@ -108,7 +111,8 @@
     char *old_reply;
     char *old_filepath;
     char typecode;
-    struct {
+    struct
+    {
 	int fd;
 	char *buf;
 	size_t size;
@@ -118,8 +122,10 @@
 	char *last_command;
 	char *last_reply;
 	int replycode;
-    } ctrl;
-    struct {
+    }
+    ctrl;
+    struct
+    {
 	int fd;
 	char *buf;
 	size_t size;
@@ -127,19 +133,23 @@
 	FREE *freefunc;
 	char *host;
 	u_short port;
-    } data;
+    }
+    data;
     struct _ftp_flags flags;
     FwdState *fwd;
-} FtpStateData;
+}
+FtpStateData;
 
-typedef struct {
+typedef struct
+{
     char type;
     int size;
     char *date;
     char *name;
     char *showname;
     char *link;
-} ftpListParts;
+}
+ftpListParts;
 
 typedef void (FTPSM) (FtpStateData *);
 
@@ -158,7 +168,8 @@
 static wordlist *ftpParseControlReply(char *, size_t, int *, int *);
 static int ftpRestartable(FtpStateData * ftpState);
 static void ftpAppendSuccessHeader(FtpStateData * ftpState);
-static void ftpAuthRequired(HttpReply * reply, request_t * request, const char *realm);
+static void ftpAuthRequired(HttpReply * reply, request_t * request,
+    const char *realm);
 static void ftpHackShortcut(FtpStateData * ftpState, FTPSM * nextState);
 static void ftpPutStart(FtpStateData *);
 static CWCB ftpPutTransferDone;
@@ -238,8 +249,7 @@
 Quit			-
 ************************************************/
 
-FTPSM *FTP_SM_FUNCS[] =
-{
+FTPSM *FTP_SM_FUNCS[] = {
     ftpReadWelcome,		/* BEGIN */
     ftpReadUser,		/* SENT_USER */
     ftpReadPass,		/* SENT_PASS */
@@ -419,22 +429,20 @@
     storeBuffer(e);
     storeAppendPrintf(e, "</PRE>\n");
     if (ftpState->flags.listformat_unknown && !ftpState->flags.tried_nlst) {
-	storeAppendPrintf(e, "<A HREF=\"./;type=d\">[As plain directory]</A>\n");
+	storeAppendPrintf(e,
+	    "<A HREF=\"./;type=d\">[As plain directory]</A>\n");
     } else if (ftpState->typecode == 'D') {
 	storeAppendPrintf(e, "<A HREF=\"./\">[As extended directory]</A>\n");
     }
     storeAppendPrintf(e, "<HR>\n");
     storeAppendPrintf(e, "<ADDRESS>\n");
     storeAppendPrintf(e, "Generated %s by %s (%s)\n",
-	mkrfc1123(squid_curtime),
-	getMyHostname(),
-	full_appname_string);
+	mkrfc1123(squid_curtime), getMyHostname(), full_appname_string);
     storeAppendPrintf(e, "</ADDRESS></BODY></HTML>\n");
     storeBufferFlush(e);
 }
 
-static const char *Month[] =
-{
+static const char *Month[] = {
     "Jan", "Feb", "Mar", "Apr", "May", "Jun",
     "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
 };
@@ -493,8 +501,8 @@
 	p->type = '\0';
 	return p;
     }
-    for (t = strtok(xbuf, w_space); t && n_tokens < MAX_TOKENS; t = strtok(NULL, w_space))
-	tokens[n_tokens++] = xstrdup(t);
+    for (t = strtok(xbuf, w_space); t && n_tokens < MAX_TOKENS;
+	t = strtok(NULL, w_space)) tokens[n_tokens++] = xstrdup(t);
     xfree(xbuf);
     /* locate the Month field */
     for (i = 3; i < n_tokens - 2; i++) {
@@ -536,7 +544,7 @@
     /* try it as a DOS listing */
     if (n_tokens > 3 && p->name == NULL &&
 	sscanf(tokens[0], SCAN_FTP3, sbuf, sbuf, sbuf) == 3 &&
-    /* 04-05-70 */
+	/* 04-05-70 */
 	sscanf(tokens[1], SCAN_FTP4, sbuf, sbuf, sbuf, sbuf) == 4) {
 	/* 09:33PM */
 	if (!strcasecmp(tokens[2], "<dir>")) {
@@ -645,7 +653,8 @@
     LOCAL_ARRAY(char, html, 8192);
     size_t width = Config.Ftp.list_width;
     ftpListParts *parts;
-    *icon = *href = *text = *size = *chdir = *view = *download = *link = *html = '\0';
+    *icon = *href = *text = *size = *chdir = *view = *download = *link = *html =
+	'\0';
     if ((int) strlen(line) > 1024) {
 	snprintf(html, 8192, "%s\n", line);
 	return html;
@@ -654,8 +663,7 @@
     if (strcmp(line, "<internal-dirup>") == 0) {
 	/* <A HREF="{href}">{icon}</A> <A HREF="{href}">{text}</A> {link} */
 	snprintf(icon, 2048, "<IMG BORDER=0 SRC=\"%s\" ALT=\"%-6s\">",
-	    mimeGetIconURL("internal-dirup"),
-	    "[DIRUP]");
+	    mimeGetIconURL("internal-dirup"), "[DIRUP]");
 	if (!ftpState->flags.no_dotdot && !ftpState->flags.root_dir) {
 	    /* Normal directory */
 	    strcpy(href, "../");
@@ -665,15 +673,12 @@
 	    strcpy(href, "%2e%2e/");
 	    strcpy(text, "Parent Directory");
 	    snprintf(link, 2048, "(<A HREF=\"%s\">%s</A>)",
-		"%2f/",
-		"Root Directory");
+		"%2f/", "Root Directory");
 	} else if (ftpState->flags.no_dotdot && !ftpState->flags.root_dir) {
 	    /* Normal directory where last component is / or ..  */
 	    strcpy(href, "%2e%2e/");
 	    strcpy(text, "Parent Directory");
-	    snprintf(link, 2048, "(<A HREF=\"%s\">%s</A>)",
-		"../",
-		"Back");
+	    snprintf(link, 2048, "(<A HREF=\"%s\">%s</A>)", "../", "Back");
 	} else {		/* NO_DOTDOT && ROOT_DIR */
 	    /* "UNIX Root" directory */
 	    strcpy(href, "../");
@@ -711,50 +716,46 @@
     switch (parts->type) {
     case 'd':
 	snprintf(icon, 2048, "<IMG BORDER=0 SRC=\"%s\" ALT=\"%-6s\">",
-	    mimeGetIconURL("internal-dir"),
-	    "[DIR]");
+	    mimeGetIconURL("internal-dir"), "[DIR]");
 	strncat(href, "/", 2048);
 	break;
     case 'l':
 	snprintf(icon, 2048, "<IMG BORDER=0 SRC=\"%s\" ALT=\"%-6s\">",
-	    mimeGetIconURL("internal-link"),
-	    "[LINK]");
+	    mimeGetIconURL("internal-link"), "[LINK]");
 	/* sometimes there is an 'l' flag, but no "->" link */
 	if (parts->link) {
 	    char *link2 = xstrdup(html_quote(rfc1738_escape(parts->link)));
 	    snprintf(link, 2048, " -> <A HREF=\"%s\">%s</A>",
-		link2,
-		html_quote(parts->link));
+		link2, html_quote(parts->link));
 	    safe_free(link2);
 	}
 	break;
     case '\0':
 	snprintf(icon, 2048, "<IMG BORDER=0 SRC=\"%s\" ALT=\"%-6s\">",
-	    mimeGetIconURL(parts->name),
-	    "[UNKNOWN]");
-	snprintf(chdir, 2048, " <A HREF=\"%s/;type=d\"><IMG BORDER=0 SRC=\"%s\" "
-	    "ALT=\"[DIR]\"></A>",
-	    rfc1738_escape_part(parts->name),
+	    mimeGetIconURL(parts->name), "[UNKNOWN]");
+	snprintf(chdir, 2048,
+	    " <A HREF=\"%s/;type=d\"><IMG BORDER=0 SRC=\"%s\" "
+	    "ALT=\"[DIR]\"></A>", rfc1738_escape_part(parts->name),
 	    mimeGetIconURL("internal-dir"));
 	break;
     case '-':
     default:
 	snprintf(icon, 2048, "<IMG BORDER=0 SRC=\"%s\" ALT=\"%-6s\">",
-	    mimeGetIconURL(parts->name),
-	    "[FILE]");
+	    mimeGetIconURL(parts->name), "[FILE]");
 	snprintf(size, 2048, " %6dk", parts->size);
 	break;
     }
     if (parts->type != 'd') {
 	if (mimeGetViewOption(parts->name)) {
-	    snprintf(view, 2048, " <A HREF=\"%s;type=a\"><IMG BORDER=0 SRC=\"%s\" "
-		"ALT=\"[VIEW]\"></A>",
-		href, mimeGetIconURL("internal-view"));
+	    snprintf(view, 2048,
+		" <A HREF=\"%s;type=a\"><IMG BORDER=0 SRC=\"%s\" "
+		"ALT=\"[VIEW]\"></A>", href, mimeGetIconURL("internal-view"));
 	}
 	if (mimeGetDownloadOption(parts->name)) {
-	    snprintf(download, 2048, " <A HREF=\"%s;type=i\"><IMG BORDER=0 SRC=\"%s\" "
-		"ALT=\"[DOWNLOAD]\"></A>",
-		href, mimeGetIconURL("internal-download"));
+	    snprintf(download, 2048,
+		" <A HREF=\"%s;type=i\"><IMG BORDER=0 SRC=\"%s\" "
+		"ALT=\"[DOWNLOAD]\"></A>", href,
+		mimeGetIconURL("internal-download"));
 	}
     }
     /* <A HREF="{href}">{icon}</A> <A HREF="{href}">{text}</A> . . . {date}{size}{chdir}{view}{download}{link}\n  */
@@ -880,11 +881,7 @@
 #endif
     memset(ftpState->data.buf + ftpState->data.offset, '\0', read_sz);
     Counter.syscalls.sock.reads++;
-#ifdef _SQUID_MSWIN_
-    len = recv(fd, ftpState->data.buf + ftpState->data.offset, read_sz);
-#else
     len = read(fd, ftpState->data.buf + ftpState->data.offset, read_sz);
-#endif
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
 #if DELAY_POOLS
@@ -908,10 +905,7 @@
 	debug(50, 1) ("ftpDataRead: read error: %s\n", xstrerror());
 	if (ignoreErrno(errno)) {
 	    commSetSelect(fd,
-		COMM_SELECT_READ,
-		ftpDataRead,
-		data,
-		Config.Timeout.read);
+		COMM_SELECT_READ, ftpDataRead, data, Config.Timeout.read);
 	} else {
 	    ftpFailed(ftpState, ERR_READ_ERROR);
 	    /* ftpFailed closes ctrl.fd and frees ftpState */
@@ -926,13 +920,11 @@
 	    storeAppend(entry, ftpState->data.buf, len);
 	    ftpState->data.offset = 0;
 	}
-	if (ftpState->size > 0 && mem->inmem_hi >= ftpState->size + mem->reply->hdr_sz)
-	    ftpReadComplete(ftpState);
+	if (ftpState->size > 0
+	    && mem->inmem_hi >=
+	    ftpState->size + mem->reply->hdr_sz) ftpReadComplete(ftpState);
 	else
-	    commSetSelect(fd,
-		COMM_SELECT_READ,
-		ftpDataRead,
-		data,
+	    commSetSelect(fd, COMM_SELECT_READ, ftpDataRead, data,
 		Config.Timeout.read);
     }
 }
@@ -1006,8 +998,7 @@
     request_t *request = ftpState->request;
     size_t len;
     char *t;
-    len = 64
-	+ strlen(ftpState->user)
+    len = 64 + strlen(ftpState->user)
 	+ strlen(ftpState->password)
 	+ strlen(request->host)
 	+ strLen(request->urlpath);
@@ -1121,16 +1112,13 @@
     safe_free(ftpState->ctrl.last_reply);
     ftpState->ctrl.last_command = xstrdup(buf);
     comm_write(ftpState->ctrl.fd,
-	xstrdup(buf),
-	strlen(buf),
-	ftpWriteCommandCallback,
-	ftpState,
-	xfree);
+	xstrdup(buf), strlen(buf), ftpWriteCommandCallback, ftpState, xfree);
     ftpScheduleReadControlReply(ftpState, 0);
 }
 
 static void
-ftpWriteCommandCallback(int fd, char *bufnotused, size_t size, int errflag, void *data)
+ftpWriteCommandCallback(int fd, char *bufnotused, size_t size, int errflag,
+    void *data)
 {
     FtpStateData *ftpState = data;
     debug(9, 7) ("ftpWriteCommandCallback: wrote %d bytes\n", size);
@@ -1224,9 +1212,7 @@
     } else {
 	commSetSelect(ftpState->ctrl.fd,
 	    COMM_SELECT_READ,
-	    ftpReadControlReply,
-	    ftpState,
-	    Config.Timeout.read);
+	    ftpReadControlReply, ftpState, Config.Timeout.read);
 	/*
 	 * Cancel the timeout on the Data socket (if any) and
 	 * establish one on the control socket.
@@ -1251,15 +1237,9 @@
     }
     assert(ftpState->ctrl.offset < ftpState->ctrl.size);
     Counter.syscalls.sock.reads++;
-#ifdef _SQUID_MSWIN_
-    len = recv(fd,
-	ftpState->ctrl.buf + ftpState->ctrl.offset,
-	ftpState->ctrl.size - ftpState->ctrl.offset);
-#else
     len = read(fd,
 	ftpState->ctrl.buf + ftpState->ctrl.offset,
 	ftpState->ctrl.size - ftpState->ctrl.offset);
-#endif
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
 	kb_incr(&Counter.server.all.kbytes_in, len);
@@ -1369,8 +1349,7 @@
 {
     if (ftpState->proxy_host != NULL)
 	snprintf(cbuf, 1024, "USER %s@%s\r\n",
-	    ftpState->user,
-	    ftpState->request->host);
+	    ftpState->user, ftpState->request->host);
     else
 	snprintf(cbuf, 1024, "USER %s\r\n", ftpState->user);
     ftpWriteCommand(cbuf, ftpState);
@@ -1649,8 +1628,7 @@
 	ftpState->size = atoi(ftpState->ctrl.last_reply);
 	if (ftpState->size == 0) {
 	    debug(9, 2) ("ftpReadSize: SIZE reported %s on %s\n",
-		ftpState->ctrl.last_reply,
-		ftpState->title_url);
+		ftpState->ctrl.last_reply, ftpState->title_url);
 	    ftpState->size = -1;
 	}
     } else if (code < 0) {
@@ -1687,15 +1665,7 @@
 	addr.sin_addr = Config.Addrs.tcp_outgoing;
     }
     /* Open data channel with the same local address as control channel */
-    fd = comm_open(SOCK_STREAM,
-#ifdef _SQUID_MSWIN_
-	IPPROTO_TCP,
-#else
-	0,
-#endif
-	addr.sin_addr,
-	0,
-	COMM_NONBLOCKING,
+    fd = comm_open(SOCK_STREAM, 0, addr.sin_addr, 0, COMM_NONBLOCKING,
 	storeUrl(ftpState->entry));
     debug(9, 3) ("ftpSendPasv: Unconnected data socket created on FD %d\n", fd);
     if (fd < 0) {
@@ -1780,7 +1750,8 @@
     FtpStateData *ftpState = data;
     debug(9, 3) ("ftpPasvCallback\n");
     if (status != COMM_OK) {
-	debug(9, 2) ("ftpPasvCallback: failed to connect. Retrying without PASV.\n");
+	debug(9,
+	    2) ("ftpPasvCallback: failed to connect. Retrying without PASV.\n");
 	ftpState->fwd->flags.dont_retry = 0;	/* this is a retryable error */
 	ftpState->fwd->flags.ftp_pasv_failed = 1;
 	ftpFailed(ftpState, ERR_NONE);
@@ -1821,20 +1792,16 @@
      * used for both control and data.
      */
     if (fallback) {
-	setsockopt(ftpState->ctrl.fd, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on));
+	setsockopt(ftpState->ctrl.fd, SOL_SOCKET, SO_REUSEADDR, (char *) &on,
+	    sizeof(on));
 	port = ntohs(addr.sin_port);
     }
-    fd = comm_open(SOCK_STREAM,
-#ifdef _SQUID_MSWIN_
-	IPPROTO_TCP,
-#else
-	0,
-#endif
-	addr.sin_addr,
-	port,
+    fd = comm_open(SOCK_STREAM, 0, addr.sin_addr, port,
 	COMM_NONBLOCKING | (fallback ? COMM_REUSEADDR : 0),
 	storeUrl(ftpState->entry));
-    debug(9, 3) ("ftpOpenListenSocket: Unconnected data socket created on FD %d\n", fd);
+    debug(9,
+	3) ("ftpOpenListenSocket: Unconnected data socket created on FD %d\n",
+	fd);
     if (fd < 0) {
 	debug(9, 0) ("ftpOpenListenSocket: comm_open failed\n");
 	return -1;
@@ -1870,8 +1837,7 @@
     addrptr = (unsigned char *) &addr.sin_addr.s_addr;
     portptr = (unsigned char *) &addr.sin_port;
     snprintf(cbuf, 1024, "PORT %d,%d,%d,%d,%d,%d\r\n",
-	addrptr[0], addrptr[1], addrptr[2], addrptr[3],
-	portptr[0], portptr[1]);
+	addrptr[0], addrptr[1], addrptr[2], addrptr[3], portptr[0], portptr[1]);
     ftpWriteCommand(cbuf, ftpState);
     ftpState->state = SENT_PORT;
 }
@@ -1899,14 +1865,16 @@
 
     fd = comm_accept(fd, &my_peer, &me);
     if (fd < 0) {
-	debug(9, 1) ("ftpHandleDataAccept: comm_accept(%d): %s", fd, xstrerror());
+	debug(9, 1) ("ftpHandleDataAccept: comm_accept(%d): %s", fd,
+	    xstrerror());
 	/* XXX Need to set error message */
 	ftpFail(ftpState);
 	return;
     }
     /* Replace the Listen socket with the accepted data socket */
     comm_close(ftpState->data.fd);
-    debug(9, 3) ("ftpAcceptDataConnection: Connected data socket on FD %d\n", fd);
+    debug(9, 3) ("ftpAcceptDataConnection: Connected data socket on FD %d\n",
+	fd);
     ftpState->data.fd = fd;
     ftpState->data.port = ntohs(my_peer.sin_port);
     ftpState->data.host = xstrdup(inet_ntoa(my_peer.sin_addr));
@@ -1949,7 +1917,8 @@
 	snprintf(cbuf, 1024, "STOR %s\r\n", ftpState->filepath);
 	ftpWriteCommand(cbuf, ftpState);
 	ftpState->state = SENT_STOR;
-    } else if (httpHeaderGetInt(&ftpState->request->header, HDR_CONTENT_LENGTH) > 0) {
+    } else if (httpHeaderGetInt(&ftpState->request->header,
+	    HDR_CONTENT_LENGTH) > 0) {
 	/* File upload without a filename. use STOU to generate one */
 	snprintf(cbuf, 1024, "STOU\r\n");
 	ftpWriteCommand(cbuf, ftpState);
@@ -1980,10 +1949,7 @@
 	/* Accept data channel */
 	debug(9, 3) ("ftpReadStor: accepting data channel\n");
 	commSetSelect(ftpState->data.fd,
-	    COMM_SELECT_READ,
-	    ftpAcceptDataConnection,
-	    ftpState,
-	    0);
+	    COMM_SELECT_READ, ftpAcceptDataConnection, ftpState, 0);
     } else {
 	debug(9, 3) ("ftpReadStor: Unexpected reply code %s\n", code);
 	ftpFail(ftpState);
@@ -2010,7 +1976,9 @@
     if (ftpState->size <= 0)
 	return 0;
 
-    ftpState->restart_offset = httpHdrRangeLowestOffset(ftpState->request->range, (size_t) ftpState->size);
+    ftpState->restart_offset =
+	httpHdrRangeLowestOffset(ftpState->request->range,
+	(size_t) ftpState->size);
     if (ftpState->restart_offset <= 0)
 	return 0;
     return 1;
@@ -2070,10 +2038,7 @@
 	/* Begin data transfer */
 	ftpAppendSuccessHeader(ftpState);
 	commSetSelect(ftpState->data.fd,
-	    COMM_SELECT_READ,
-	    ftpDataRead,
-	    ftpState,
-	    Config.Timeout.read);
+	    COMM_SELECT_READ, ftpDataRead, ftpState, Config.Timeout.read);
 	commSetDefer(ftpState->data.fd, fwdCheckDeferRead, ftpState->entry);
 	ftpState->state = READING_DATA;
 	/*
@@ -2081,21 +2046,20 @@
 	 * on the data socket
 	 */
 	commSetTimeout(ftpState->ctrl.fd, -1, NULL, NULL);
-	commSetTimeout(ftpState->data.fd, Config.Timeout.read, ftpTimeout, ftpState);
+	commSetTimeout(ftpState->data.fd, Config.Timeout.read, ftpTimeout,
+	    ftpState);
 	return;
     } else if (code == 150) {
 	/* Accept data channel */
 	commSetSelect(ftpState->data.fd,
-	    COMM_SELECT_READ,
-	    ftpAcceptDataConnection,
-	    ftpState,
-	    0);
+	    COMM_SELECT_READ, ftpAcceptDataConnection, ftpState, 0);
 	/*
 	 * Cancel the timeout on the Control socket and establish one
 	 * on the data socket
 	 */
 	commSetTimeout(ftpState->ctrl.fd, -1, NULL, NULL);
-	commSetTimeout(ftpState->data.fd, Config.Timeout.read, ftpTimeout, ftpState);
+	commSetTimeout(ftpState->data.fd, Config.Timeout.read, ftpTimeout,
+	    ftpState);
 	return;
     } else if (!ftpState->flags.tried_nlst && code > 300) {
 	ftpSendNlst(ftpState);
@@ -2124,10 +2088,7 @@
 	debug(9, 3) ("ftpReadRetr: reading data channel\n");
 	ftpAppendSuccessHeader(ftpState);
 	commSetSelect(ftpState->data.fd,
-	    COMM_SELECT_READ,
-	    ftpDataRead,
-	    ftpState,
-	    Config.Timeout.read);
+	    COMM_SELECT_READ, ftpDataRead, ftpState, Config.Timeout.read);
 	commSetDefer(ftpState->data.fd, fwdCheckDeferRead, ftpState->entry);
 	ftpState->state = READING_DATA;
 	/*
@@ -2140,10 +2101,7 @@
     } else if (code == 150) {
 	/* Accept data channel */
 	commSetSelect(ftpState->data.fd,
-	    COMM_SELECT_READ,
-	    ftpAcceptDataConnection,
-	    ftpState,
-	    0);
+	    COMM_SELECT_READ, ftpAcceptDataConnection, ftpState, 0);
 	/*
 	 * Cancel the timeout on the Control socket and establish one
 	 * on the data socket
@@ -2299,8 +2257,7 @@
 	}
     }
     /* Try to reopen datachannel */
-    if (!ftpState->flags.datachannel_hack &&
-	ftpState->pathcomps == NULL) {
+    if (!ftpState->flags.datachannel_hack && ftpState->pathcomps == NULL) {
 	switch (ftpState->state) {
 	case SENT_RETR:
 	case SENT_LIST:
@@ -2416,7 +2373,8 @@
 }
 
 static void
-ftpPutTransferDone(int fd, char *bufnotused, size_t size, int errflag, void *data)
+ftpPutTransferDone(int fd, char *bufnotused, size_t size, int errflag,
+    void *data)
 {
     FtpStateData *ftpState = data;
     if (ftpState->data.fd >= 0) {
@@ -2439,7 +2397,8 @@
     if (cbdataValid(ftpState))
 	debug(9, 5) ("ftpSendReply: ftpState (%p) is valid!\n", ftpState);
     if (code == 226) {
-	err_code = (ftpState->mdtm > 0) ? ERR_FTP_PUT_MODIFIED : ERR_FTP_PUT_CREATED;
+	err_code =
+	    (ftpState->mdtm > 0) ? ERR_FTP_PUT_MODIFIED : ERR_FTP_PUT_CREATED;
 	http_code = (ftpState->mdtm > 0) ? HTTP_ACCEPTED : HTTP_CREATED;
     } else if (code == 227) {
 	err_code = ERR_FTP_PUT_CREATED;
@@ -2506,7 +2465,8 @@
 	range_spec.offset = ftpState->restarted_offset;
 	range_spec.length = ftpState->size - ftpState->restarted_offset;
 	httpReplySetHeaders(reply, 1.0, HTTP_PARTIAL_CONTENT, "Gatewaying",
-	    mime_type, ftpState->size - ftpState->restarted_offset, ftpState->mdtm, -2);
+	    mime_type, ftpState->size - ftpState->restarted_offset,
+	    ftpState->mdtm, -2);
 	httpHeaderAddContRange(&reply->header, range_spec, ftpState->size);
     } else {
 	/* Full reply */
@@ -2529,7 +2489,8 @@
 	if (pe)
 	    storeRelease(pe);
 	storeRelease(e);
-    } else if (EBIT_TEST(e->flags, ENTRY_CACHABLE) && !ftpState->restarted_offset) {
+    } else if (EBIT_TEST(e->flags, ENTRY_CACHABLE)
+	&& !ftpState->restarted_offset) {
 	storeSetPublicKey(e);
     } else {
 	storeRelease(e);
@@ -2571,11 +2532,7 @@
     }
     snprintf(buf, MAX_URL, "%s://%s%s%s%s%s",
 	ProtocolStr[request->protocol],
-	loginbuf,
-	request->host,
-	portbuf,
-	"/%2f",
-	strBuf(request->urlpath));
+	loginbuf, request->host, portbuf, "/%2f", strBuf(request->urlpath));
     if ((t = strchr(buf, '?')))
 	*t = '\0';
     return buf;
Index: squid/src/globals.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/globals.h,v
retrieving revision 1.1.1.3.4.2.2.4
retrieving revision 1.1.1.3.4.2.2.4.2.1
diff -u -r1.1.1.3.4.2.2.4 -r1.1.1.3.4.2.2.4.2.1
--- squid/src/globals.h	29 Jul 2001 16:06:05 -0000	1.1.1.3.4.2.2.4
+++ squid/src/globals.h	27 Aug 2001 21:48:21 -0000	1.1.1.3.4.2.2.4.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: globals.h,v 1.1.1.3.4.2.2.4 2001/07/29 16:06:05 serassio Exp $
+ * $Id: globals.h,v 1.1.1.3.4.2.2.4.2.1 2001/08/27 21:48:21 tolsty Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -65,7 +64,7 @@
 extern dnsStatData DnsStats;
 #ifdef _SQUID_MSWIN_
 extern sde *sd_table;		/* NULL */
-extern int Biggest_SD;		/* 0 */
+extern int Biggest_SD;		/* -1 */
 extern int Number_SD;		/* 0 */
 #endif
 extern fde *fd_table;		/* NULL */
@@ -144,7 +143,7 @@
 extern int _db_level;
 extern const int CacheDigestHashFuncCount;	/* 4 */
 extern CacheDigest *store_digest;	/* NULL */
-extern const char *StoreDigestFileName;		/* "store_digest" */
+extern const char *StoreDigestFileName;	/* "store_digest" */
 extern const char *StoreDigestMimeStr;	/* "application/cache-digest" */
 #if USE_CACHE_DIGESTS
 extern const Version CacheDigestVer;	/* { 5, 3 } */
@@ -160,9 +159,9 @@
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
 extern unsigned int WIN32_OS_version;	/* 0 */
 extern char *WIN32_OS_string;
-extern char *WIN32_Service_name; /* NULL */
+extern char *WIN32_Service_name;	/* NULL */
 extern unsigned int WIN32_run_mode;	/* _WIN_SQUID_RUN_MODE_INTERACTIVE */
 #if defined(_SQUID_MSWIN_) && defined(_DEBUG)
-extern int do_debug;	/* 0 */
+extern int do_debug;		/* 0 */
 #endif
 #endif
Index: squid/src/gopher.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/gopher.c,v
retrieving revision 1.1.1.3.4.2.2.1
retrieving revision 1.1.1.3.4.2.2.1.2.1
diff -u -r1.1.1.3.4.2.2.1 -r1.1.1.3.4.2.2.1.2.1
--- squid/src/gopher.c	6 Jan 2001 12:40:14 -0000	1.1.1.3.4.2.2.1
+++ squid/src/gopher.c	27 Aug 2001 21:48:21 -0000	1.1.1.3.4.2.2.1.2.1
@@ -1,7 +1,5 @@
-
-
 /*
- * $Id: gopher.c,v 1.1.1.3.4.2.2.1 2001/01/06 12:40:14 hno Exp $
+ * $Id: gopher.c,v 1.1.1.3.4.2.2.1.2.1 2001/08/27 21:48:21 tolsty Exp $
  *
  * DEBUG: section 10    Gopher
  * AUTHOR: Harvest Derived
@@ -68,17 +66,20 @@
 #define TEMP_BUF_SIZE       4096
 #define MAX_CSO_RESULT      1024
 
-typedef struct gopher_ds {
+typedef struct gopher_ds
+{
     StoreEntry *entry;
     char host[SQUIDHOSTNAMELEN + 1];
-    enum {
+    enum
+    {
 	NORMAL,
 	HTML_DIR,
 	HTML_INDEX_RESULT,
 	HTML_CSO_RESULT,
 	HTML_INDEX_PAGE,
 	HTML_CSO_PAGE
-    } conversion;
+    }
+    conversion;
     int HTML_header_added;
     int port;
     char type_id;
@@ -89,16 +90,14 @@
     char *buf;			/* pts to a 4k page */
     int fd;
     FwdState *fwdState;
-} GopherStateData;
+}
+GopherStateData;
 
 static PF gopherStateFree;
 static void gopher_mime_content(MemBuf * mb, const char *name, const char *def);
 static void gopherMimeCreate(GopherStateData *);
 static int gopher_url_parser(const char *url,
-    char *host,
-    int *port,
-    char *type_id,
-    char *request);
+    char *host, int *port, char *type_id, char *request);
 static void gopherEndHTML(GopherStateData *);
 static void gopherToHTML(GopherStateData *, char *inbuf, int len);
 static PF gopherTimeout;
@@ -133,8 +132,7 @@
     char *cenc = mimeGetContentEncoding(name);
     if (cenc)
 	memBufPrintf(mb, "Content-Encoding: %s\r\n", cenc);
-    memBufPrintf(mb, "Content-Type: %s\r\n",
-	ctype ? ctype : def_ctype);
+    memBufPrintf(mb, "Content-Type: %s\r\n", ctype ? ctype : def_ctype);
 }
 
 
@@ -151,8 +149,7 @@
 	"HTTP/1.0 200 OK Gatewaying\r\n"
 	"Server: Squid/%s\r\n"
 	"Date: %s\r\n"
-	"MIME-version: 1.0\r\n",
-	version_string, mkrfc1123(squid_curtime));
+	"MIME-version: 1.0\r\n", version_string, mkrfc1123(squid_curtime));
 
     switch (gopherState->type_id) {
 
@@ -195,7 +192,8 @@
 
 /* Parse a gopher url into components.  By Anawat. */
 static int
-gopher_url_parser(const char *url, char *host, int *port, char *type_id, char *request)
+gopher_url_parser(const char *url, char *host, int *port, char *type_id,
+    char *request)
 {
     LOCAL_ARRAY(char, proto, MAX_URL);
     LOCAL_ARRAY(char, hostbuf, MAX_URL);
@@ -242,9 +240,7 @@
     /* parse to see type */
     gopher_url_parser(url,
 	gopherState->host,
-	&gopherState->port,
-	&gopherState->type_id,
-	gopherState->request);
+	&gopherState->port, &gopherState->type_id, gopherState->request);
     switch (gopherState->type_id) {
     case GOPHER_INDEX:
     case GOPHER_CSO:
@@ -301,8 +297,7 @@
 	    "<BODY><H1>%s<BR>Gopher Search</H1>\n"
 	    "<p>This is a searchable Gopher index. Use the search\n"
 	    "function of your browser to enter search terms.\n"
-	    "<ISINDEX></BODY></HTML>\n",
-	    storeUrl(entry), storeUrl(entry));
+	    "<ISINDEX></BODY></HTML>\n", storeUrl(entry), storeUrl(entry));
 	/* now let start sending stuff to client */
 	storeBufferFlush(entry);
 	gopherState->data_in = 1;
@@ -327,10 +322,12 @@
 
     if (!gopherState->HTML_header_added) {
 	if (gopherState->conversion == HTML_CSO_RESULT)
-	    strcat(outbuf, "<HTML><HEAD><TITLE>CSO Searchs Result</TITLE></HEAD>\n"
+	    strcat(outbuf,
+		"<HTML><HEAD><TITLE>CSO Searchs Result</TITLE></HEAD>\n"
 		"<BODY><H1>CSO Searchs Result</H1>\n<PRE>\n");
 	else
-	    strcat(outbuf, "<HTML><HEAD><TITLE>Gopher Menu</TITLE></HEAD>\n"
+	    strcat(outbuf,
+		"<HTML><HEAD><TITLE>Gopher Menu</TITLE></HEAD>\n"
 		"<BODY><H1>Gopher Menu</H1>\n<PRE>\n");
 	gopherState->HTML_header_added = 1;
     }
@@ -346,7 +343,10 @@
 		/* there is no complete line in inbuf */
 		/* copy it to temp buffer */
 		if (gopherState->len + len > TEMP_BUF_SIZE) {
-		    debug(10, 1) ("GopherHTML: Buffer overflow. Lost some data on URL: %s\n",
+		    debug(10, 1)
+
+			
+			("GopherHTML: Buffer overflow. Lost some data on URL: %s\n",
 			storeUrl(entry));
 		    len = TEMP_BUF_SIZE - gopherState->len;
 		}
@@ -372,7 +372,10 @@
 		/* there is no complete line in inbuf */
 		/* copy it to temp buffer */
 		if ((len - (pos - inbuf)) > TEMP_BUF_SIZE) {
-		    debug(10, 1) ("GopherHTML: Buffer overflow. Lost some data on URL: %s\n",
+		    debug(10, 1)
+
+			
+			("GopherHTML: Buffer overflow. Lost some data on URL: %s\n",
 			storeUrl(entry));
 		    len = TEMP_BUF_SIZE;
 		}
@@ -431,7 +434,8 @@
 				port[0] = 0;	/* 0 means none */
 			}
 			/* escape a selector here */
-			escaped_selector = xstrdup(rfc1738_escape_part(selector));
+			escaped_selector =
+			    xstrdup(rfc1738_escape_part(selector));
 
 			switch (gtype) {
 			case GOPHER_DIRECTORY:
@@ -474,17 +478,22 @@
 			memset(tmpbuf, '\0', TEMP_BUF_SIZE);
 			if ((gtype == GOPHER_TELNET) || (gtype == GOPHER_3270)) {
 			    if (strlen(escaped_selector) != 0)
-				snprintf(tmpbuf, TEMP_BUF_SIZE, "<IMG BORDER=0 SRC=\"%s\"> <A HREF=\"telnet://%s@%s%s%s/\">%s</A>\n",
-				    icon_url, escaped_selector, rfc1738_escape_part(host),
-				    *port ? ":" : "", port, html_quote(name));
-			    else
-				snprintf(tmpbuf, TEMP_BUF_SIZE, "<IMG BORDER=0 SRC=\"%s\"> <A HREF=\"telnet://%s%s%s/\">%s</A>\n",
-				    icon_url, rfc1738_escape_part(host), *port ? ":" : "",
+				snprintf(tmpbuf, TEMP_BUF_SIZE,
+				    "<IMG BORDER=0 SRC=\"%s\"> <A HREF=\"telnet://%s@%s%s%s/\">%s</A>\n",
+				    icon_url, escaped_selector,
+				    rfc1738_escape_part(host), *port ? ":" : "",
 				    port, html_quote(name));
+			    else
+				snprintf(tmpbuf, TEMP_BUF_SIZE,
+				    "<IMG BORDER=0 SRC=\"%s\"> <A HREF=\"telnet://%s%s%s/\">%s</A>\n",
+				    icon_url, rfc1738_escape_part(host),
+				    *port ? ":" : "", port, html_quote(name));
 
 			} else {
-			    snprintf(tmpbuf, TEMP_BUF_SIZE, "<IMG BORDER=0 SRC=\"%s\"> <A HREF=\"gopher://%s/%c%s\">%s</A>\n",
-				icon_url, host, gtype, escaped_selector, html_quote(name));
+			    snprintf(tmpbuf, TEMP_BUF_SIZE,
+				"<IMG BORDER=0 SRC=\"%s\"> <A HREF=\"gopher://%s/%c%s\">%s</A>\n",
+				icon_url, host, gtype, escaped_selector,
+				html_quote(name));
 			}
 			safe_free(escaped_selector);
 			strcat(outbuf, tmpbuf);
@@ -518,10 +527,13 @@
 			break;
 
 		    if (gopherState->cso_recno != recno) {
-			snprintf(tmpbuf, TEMP_BUF_SIZE, "</PRE><HR><H2>Record# %d<br><i>%s</i></H2>\n<PRE>", recno, html_quote(result));
+			snprintf(tmpbuf, TEMP_BUF_SIZE,
+			    "</PRE><HR><H2>Record# %d<br><i>%s</i></H2>\n<PRE>",
+			    recno, html_quote(result));
 			gopherState->cso_recno = recno;
 		    } else {
-			snprintf(tmpbuf, TEMP_BUF_SIZE, "%s\n", html_quote(result));
+			snprintf(tmpbuf, TEMP_BUF_SIZE, "%s\n",
+			    html_quote(result));
 		    }
 		    strcat(outbuf, tmpbuf);
 		    gopherState->data_in = 1;
@@ -546,7 +558,9 @@
 		    case 502:	/* Too Many Matches */
 			{
 			    /* Print the message the server returns */
-			    snprintf(tmpbuf, TEMP_BUF_SIZE, "</PRE><HR><H2>%s</H2>\n<PRE>", html_quote(result));
+			    snprintf(tmpbuf, TEMP_BUF_SIZE,
+				"</PRE><HR><H2>%s</H2>\n<PRE>",
+				html_quote(result));
 			    strcat(outbuf, tmpbuf);
 			    gopherState->data_in = 1;
 			    break;
@@ -614,11 +628,7 @@
 #endif
     /* leave one space for \0 in gopherToHTML */
     Counter.syscalls.sock.reads++;
-#ifdef _SQUID_MSWIN_
-    len = recv(fd, buf, read_sz);
-#else
     len = read(fd, buf, read_sz);
-#endif
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
 #if DELAY_POOLS
@@ -671,10 +681,7 @@
 	} else {
 	    storeAppend(entry, buf, len);
 	}
-	commSetSelect(fd,
-	    COMM_SELECT_READ,
-	    gopherReadReply,
-	    data, 0);
+	commSetSelect(fd, COMM_SELECT_READ, gopherReadReply, data, 0);
     }
     memFree(buf, MEM_4K_BUF);
     return;
@@ -761,12 +768,7 @@
 	snprintf(buf, 4096, "%s\r\n", gopherState->request);
     }
     debug(10, 5) ("gopherSendRequest: FD %d\n", fd);
-    comm_write(fd,
-	buf,
-	strlen(buf),
-	gopherSendComplete,
-	data,
-	memFree4K);
+    comm_write(fd, buf, strlen(buf), gopherSendComplete, data, memFree4K);
     if (EBIT_TEST(gopherState->entry->flags, ENTRY_CACHABLE))
 	storeSetPublicKey(gopherState->entry);	/* Make it public */
 }
@@ -783,8 +785,8 @@
     Counter.server.all.requests++;
     Counter.server.other.requests++;
     /* Parse url. */
-    if (gopher_url_parser(storeUrl(entry), gopherState->host, &gopherState->port,
-	    &gopherState->type_id, gopherState->request)) {
+    if (gopher_url_parser(storeUrl(entry), gopherState->host,
+	    &gopherState->port, &gopherState->type_id, gopherState->request)) {
 	ErrorState *err;
 	err = errorCon(ERR_INVALID_URL, HTTP_BAD_REQUEST);
 	err->url = xstrdup(storeUrl(entry));
@@ -793,7 +795,8 @@
 	return;
     }
     comm_add_close_handler(fd, gopherStateFree, gopherState);
-    if (((gopherState->type_id == GOPHER_INDEX) || (gopherState->type_id == GOPHER_CSO))
+    if (((gopherState->type_id == GOPHER_INDEX)
+	    || (gopherState->type_id == GOPHER_CSO))
 	&& (strchr(gopherState->request, '?') == NULL)) {
 	/* Index URL without query word */
 	/* We have to generate search page back to client. No need for connection */
@@ -826,4 +829,4 @@
     gd->buf = memAllocate(MEM_4K_BUF);
     return (gd);
 }
-#endif GOPHER_C
+#endif /* GOPHER_C */
